// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.teaconsole.*;
import com.aliyun.teautil.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.darabonbanumber.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 地域ID
        String regionId = args.get(0);
        // 可用区ID
        String zoneId = args.get(1);
        // 实例规格
        String instanceType = args.get(2);
        // 交换机ID
        String vSwitchId = args.get(3);
        // 镜像ID
        String imageId = args.get(4);
        // 出价模式
        String spotStrategy = args.get(5);
        // 出价上限
        Float spotPriceLimit = com.aliyun.darabonbanumber.Client.parseFloat(args.get(6));
        // 预检请求
        // true：发送检查请求，不会创建实例。检查项包括是否填写了必需参数、请求格式、业务限制和ECS库存。如果检查不通过，则返回对应错误。如果检查通过，则返回DryRunOperation错误。
        // false：发送正常请求，通过检查后直接创建实例。
        String dryRunStr = args.get(7);
        Boolean dryRun = true;
        String securityGroupId = args.get(8);
        if (com.aliyun.teautil.Common.equalString(dryRunStr, "false")) {
            dryRun = false;
        }

        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        // 1.创建抢占式实例
        com.aliyun.teaconsole.Client.log("--------------------创建抢占式实例--------------------");
        Sample.CreateSpotInstance(client, regionId, zoneId, instanceType, imageId, vSwitchId, spotStrategy, spotPriceLimit, dryRun, securityGroupId);
        // 2.等待实例创建成功
        com.aliyun.teautil.Common.sleep(1000);
        // 2.查询实例列表
        com.aliyun.teaconsole.Client.log("--------------------查询实例列表--------------------");
        Sample.DescribeInstances(client, regionId);
    }

    /**
     * 创建抢占式实例
     * @param client
     * @param regionId
     * @param zoneId
     * @param instanceType
     * @param vSwitchId
     * @param dryRun
     * @throws Exception
     */
    public static void CreateSpotInstance(com.aliyun.ecs20140526.Client client, String regionId, String zoneId, String instanceType, String imageId, String vSwitchId, String spotStrategy, Float spotPriceLimit, Boolean dryRun, String securityGroupId) throws Exception {
        try {
            CreateInstanceRequest request = new CreateInstanceRequest()
                    .setRegionId(regionId)
                    .setZoneId(zoneId)
                    .setInstanceType(instanceType)
                    .setImageId(imageId)
                    .setVSwitchId(vSwitchId)
                    .setSpotStrategy(spotStrategy)
                    .setSpotPriceLimit(spotPriceLimit)
                    .setSecurityGroupId(securityGroupId)
                    .setSystemDisk(new CreateInstanceRequest.CreateInstanceRequestSystemDisk()
                            .setCategory("cloud_essd"))
                    .setDryRun(dryRun);
            CreateInstanceResponse response = client.createInstance(request);
            com.aliyun.teaconsole.Client.log("创建抢占式实例成功，实例ID:" + response.body.instanceId + "");
        } catch (TeaException error) {
            com.aliyun.teaconsole.Client.log(error.message);
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            com.aliyun.teaconsole.Client.log(error.message);
        }        
    }

    /**
     * 查询实例列表
     * @param client
     * @param regionId
     * @throws Exception
     */
    public static void DescribeInstances(com.aliyun.ecs20140526.Client client, String regionId) throws Exception {
        try {
            DescribeInstancesRequest request = new DescribeInstancesRequest()
                    .setRegionId(regionId);
            DescribeInstancesResponse response = client.describeInstances(request);
            java.util.List<DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance> instances = response.body.instances.instance;
            for (DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance instance : instances) {
                com.aliyun.teaconsole.Client.log("实例ID:" + instance.instanceId + "信息");
                com.aliyun.teaconsole.Client.log("状态:" + instance.status + "");
                com.aliyun.teaconsole.Client.log("CPU:" + instance.cpu + "");
                com.aliyun.teaconsole.Client.log("内存:" + instance.memory + "MB");
                com.aliyun.teaconsole.Client.log("规格:" + instance.instanceType + "");
                com.aliyun.teaconsole.Client.log("系统:" + instance.OSType + "(" + instance.OSName + ")");
            }
        } catch (TeaException error) {
            com.aliyun.teaconsole.Client.log(error.message);
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            com.aliyun.teaconsole.Client.log(error.message);
        }        
    }
}
